<template>
  <div class="home">
    <div class="followers-container">
      <h1> {{ account }}</h1>
      <span class="followers-count">{{followersCount}}</span>
    </div>
    <div class="update-container">
      Mise à jour le {{updateDate}}
    </div>
  </div>
</template>

<script lang="ts">
import { Options, Vue } from 'vue-class-component'
import { namespace } from 'vuex-class'

const InstagramStore = namespace('InstagramStore')

@Options({
  components: {}
})
export default class HomeView extends Vue {
  account = "@juliegri_"
  updateDateState = new Date()

  private INTERVAL_IN_MINUTES = 1000 * 60 * 15 // 15 MINUTES

  @InstagramStore.Getter
  private followersCount!: string

  @InstagramStore.Action
  private getFollowersCount!: () => Promise<void>

  get updateDate(): string {
    return `${this.updateDateState.toLocaleDateString()} à ${this.updateDateState.toLocaleTimeString()}`
  }

  async created(): Promise<void> {
    await this.retrieveFollowers()
    this.runInPeriodicHandler()
  }

  runInPeriodicHandler(): void {
    setInterval(async () => {
      await this.retrieveFollowers()
    }, this.INTERVAL_IN_MINUTES)
  }

  async retrieveFollowers(): Promise<void> {
    await this.getFollowersCount()
    this.updateDateState = new Date()
  }

}
</script>
<style lang="scss" scoped>
.home {
  display: flex;
  min-height: 100vh;
  background: black;
  color: white;
  justify-content: center;
  align-items: center;
  flex-direction: column;

  .followers-count {
    font-size: 3rem;
  }

  .update-container {
    margin-top: 32px;
  }
}
</style>
